﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace error
{
    class PositiveNumberRule : ValidationRule
    {
        public override ValidationResult Validate(object value, System.Globalization.CultureInfo cultureInfo)
        {
            int luku = 0;
            try
            {
                luku = Convert.ToInt16(value); ;
            }
            catch (FormatException)
            {
                return new ValidationResult(false, "Value is not a valid integer.");
            }
            if (luku <= 0)
            {
                return new ValidationResult(false, "Please enter a positive integer.");
            }
            else
            {
                return ValidationResult.ValidResult;
            }
        }
    }

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<Control> controls = new List<Control>();
        public MainWindow()
        {
            InitializeComponent();
            controls.Add(box1);
            controls.Add(box2);
            
        }
        // nimeäminen tehtävä juuri seuraavalla tavalla
        public static readonly DependencyProperty LaskuriProperty =
         DependencyProperty.Register(
           "Laskuri",
           typeof(int), // propertyn tietotyyppi
           typeof(MainWindow), // luokka jossa property sijaitsee
           new FrameworkPropertyMetadata(0,  // propertyn oletusarvo
              FrameworkPropertyMetadataOptions.SubPropertiesDoNotAffectRender,
              new PropertyChangedCallback(OnValueChanged),  // kutsutaan propertyn arvon muuttumisen jälkeen
              new CoerceValueCallback(MuutaLaskuria))); // kutsutaan ennen propertyn arvon muutosta

        // seuraavat tehtävä juuri näin. Ei mitään tarkistuksien lisäämistä
        public int Laskuri
        {
            get { return (int)GetValue(LaskuriProperty); }
            set { SetValue(LaskuriProperty, value); }
        }

        // tätä kutsutaan ennen laskurin muuttamista ja voidaan tässä vaiheessa
        // tehdä tarkistuksia ja muuttaa laskuriin asetettavaa arvoa
        private static object MuutaLaskuria(DependencyObject element, object value)
        {
            int luku = (int)value;
            if (luku < 0) value = 0;

            return luku;
        }
        private static void OnValueChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            // ei tarvita?
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Laskuri++;
        }

        private void StackPanel_Error(object sender, ValidationErrorEventArgs e)
        {
            // mikä tahansa virhe syötteissä
            this.Title = "Tuli virhe";
        }

        private void TextBox_TextChanged(object sender, TextChangedEventArgs e)
        {
            // käydään läpi kaikki halutut kontrollit ja tsekataan onko niille tullut validointivirhe
            foreach (var item in controls)
            {
                if (item != null && Validation.GetHasError(item)) MessageBox.Show("virhe");
                
            }
        }

    }
}
